<?php
// On construit un class loader pour ne plus s'occuper du chargement des fichiers
class MyClassLoader
{
  public static function loadClass($class){
    //echo 'loading '.$class;
    require "CLASS_$class.inc";
  }
}
// Enregistrement de l'autoloader
spl_autoload_register('MyClassLoader::loadClass');

// On commence par initialiser les globales pour ne pas avoir de mauvaises surprises
$utilisateur = null;
$command=false;
$login = false;
$pass = false;
$db = null;
$panier = null;

// Démarrage de la session
session_start();

// On crée l'objet de connexion à la base de donnée
$db = new DBHandle();
// On vérifie si le front controler est appelé sur une requête post et que
// l'objet utilisateur n'existe pas dans la session.
if((isset($_POST['login']))&&(!isset($_SESSION['utilisateur']))){
  // On se protège contre l'injection de code SQL
  $login=mysql_real_escape_string($_POST['login']);
  $pass=mysql_real_escape_string($_POST['password']);
  // On appelle la méthode de constuctio de l'objet utilisateur
  // En cas d'identification correcte.
  if($utilisateur = $db->authentification($login,$pass)){
    $_SESSION['utilisateur']=$utilisateur; // stockage de l'objet dans la variable de session
  }
}
$listControler = new ListeProduits($db);
if(isset($_SESSION['utilisateur'])){
  $utilisateur = $_SESSION['utilisateur'];
  if(isset($_SESSION['panier'])){
    $panier=$_SESSION['panier'];
  }
  else{
    $_SESSION['panier'] = $panier = new Panier();
  }
  $panier->setListeProduit($listControler, new VueListe());
}
// traitement des actions
if(isset($_GET['action'])){
  $command=$_GET['action'];
  switch($command){
    case "logout":
    case "buy":{
      if(!isset($utilisateur)){
        die("");
      }
      header("location:index.php?action=listerProduits");
    }
    break;
    case "remove":{
      if(!isset($utilisateur)){
        die("");
      }
      $id_prod=(int)$_GET['id'];
      $panier->removeProductByID($id_prod);
      //echo "$id_prod";
      header("location:index.php?action=panier");
    }
  }
}
else{ // par défaut on fait un listerProduits
  $command="listerProduits";
  header("Location: index.php?action=listerProduits");
}
// Construction du controler de la liste des Poduits en lui passant l'objet db
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>
MyDicount.com
</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
</head>
<body>

<div>

<?php
// Si l'objet utilisateur n'existe pas dans la session, l'utlisateur n'est pas authentifié.
// On lui envoie un formulaire d'authentification.
if(!isset($_SESSION['utilisateur'])){
// $_SERVER['QUERY_STRING'] permet de ne pas perdre de vue l'action en cours. (C'est
// insufisant en cas de passage de parametres par POST.
?>
<form <?php echo 'action="index.php?'.$_SERVER['QUERY_STRING'].'"'; ?> method="post">
<input type="textarea" name="login"/>
<input type="password" name="password"/>
<input type="submit" name="OK"/>
</form>
<?php
}
else{
  // Sinon on lui souhaite la bienvenue et on lui offre la possibilité de fermer sa session.
  echo "Welcome: ".$utilisateur->getLogin()." ";
  echo '<a href="index.php?action=logout">logout</a>';
  // On charge son panier ou on le crée si il n'y en a pas.
}
?>

</div>
<?php
// gestion des actions
switch($command){
  case "buy":
    if((isset($_POST['id']))&&(isset($_POST['qt']))){
      $panier->add((int)$_POST['id'], (int)$_POST['qt']);
    }
  case "listerProduits":
    // Génération de l'affichage de la liste de produits
    $listControler->affiche(1);
    break;
  case "panier":
    $panier->affiche(1);
    echo "<br>";
    break;
  case "logout":
    // Si l'utilisateur est authentifié, on traite la déconnection
    if($utilisateur){
      // on écrase l'objet session => appel du destructeur qui par défaut ne fait rien.
      $_SESSION=array();
      // destruction de la session PHP.
      session_destroy();
    }
  default:
    die("");
}
if($panier){
  $panier->afficheMini();
}
?>
</body>
</html>

